<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

wp_register_script(
	'gartentechnik_com_mainjs',
	plugins_url('resources/js/dummy.js', __FILE__),
	array(
		# Abhaengigkeitendie in den GT-JS, die via API kommen, benutzt werden
		'jquery','jquery-ui-core','jquery-ui-dialog','jquery-ui-autocomplete',
	),
	null,
	true
);

wp_enqueue_script('gartentechnik_com_mainjs');

wp_localize_script(
	'gartentechnik_com_mainjs',
	'gartentechnik_com_js_translation',
	array('url' => admin_url( 'admin-ajax.php' ))
);

$gartentechnik_com_anfrage_absenden = function() use ($app) {
	gartentechnik_com_debug('anfrage_absenden_start');
	echo json_encode($app->sende_anfrage(stripslashes_deep($_REQUEST)));
	gartentechnik_com_debug('anfrage_absenden_end');

	// Don't forget to exit!
	exit;
};
add_action('wp_ajax_gartentechnik_com_anfrageformular', $gartentechnik_com_anfrage_absenden, 20, 0);
add_action('wp_ajax_nopriv_gartentechnik_com_anfrageformular', $gartentechnik_com_anfrage_absenden, 20, 0);

$gartentechnik_com_sende_produktrezension = function() use ($app) {
	gartentechnik_com_debug('anfrage_absenden_start');
	echo json_encode($app->sende_produktrezension(stripslashes_deep($_REQUEST)));
	gartentechnik_com_debug('anfrage_absenden_end');

	// Don't forget to exit!
	exit;
};
add_action('wp_ajax_gartentechnik_com_produktrezension', $gartentechnik_com_sende_produktrezension, 20, 0);
add_action('wp_ajax_nopriv_gartentechnik_com_produktrezension', $gartentechnik_com_sende_produktrezension, 20, 0);

if($ist_admin_kontext || $ist_superadmin_kontext) {

	add_action('wp_ajax_gartentechnik_com_admin_api_anfrage', function() use (
		$app, $ist_admin_kontext, $ist_superadmin_kontext, $rolle_des_aktuellen_users
	) {
		gartentechnik_com_debug('admin_api_anfrage_start');
		$request_content_type = $_SERVER["CONTENT_TYPE"];
		if($request_content_type == 'application/x-www-form-urlencoded') {
			$request_content_type = null;
			$request_body = null;
		} else {
			$request_body = file_get_contents('php://input');
		}
		$result = $app->sende_admin_api_anfrage(
			stripslashes_deep($_REQUEST), $_FILES,
			$ist_admin_kontext, $ist_superadmin_kontext, $rolle_des_aktuellen_users,
			$request_content_type, $request_body
		);

		if (is_null($result)) {
			# DoNothing
		} elseif ($result['is_json']) {
			http_response_code($result['status_code']);
			if (!is_null($result['content'])) {
				echo json_encode($result['content']);
			}
		} else {
			http_response_code($result['status_code']);
			echo $result['content'];
		}
		gartentechnik_com_debug('admin_api_anfrage_end');

		// Don't forget to exit!
		exit;
	}, 20, 0);

	add_action('wp_ajax_gartentechnik_com_admin_get_all_pages', function() {
		gartentechnik_com_debug('get_all_pages_start');
		$gartentechnik_com_admin_get_all_pages = array();
		add_filter('page_menu_link_attributes', function($atts, $page, $depth, $args, $current_page) use (&$gartentechnik_com_admin_get_all_pages) {
			gartentechnik_com_debug('page_menu_link_start');
			if(is_array($gartentechnik_com_admin_get_all_pages)) {
				$slugs = \GartentechnikCom\Register::gib_post_slug($page);
				$prefix = '';
				if(count($slugs) > 1) {
					$prefix = str_repeat('— ', count($slugs) - 1);
				}
				array_push($gartentechnik_com_admin_get_all_pages, [
					'id'				=> $page->ID,
					'title'				=> $prefix . $page->post_title,
					'slug'				=> implode('/', $slugs),
					'content_length'	=> strlen($page->post_content),
				]);
			}
			gartentechnik_com_debug('page_menu_link_end');
			return $atts;
		}, 20, 5);
		wp_list_pages('echo', false, 'post_status', 'publish');
		echo json_encode($gartentechnik_com_admin_get_all_pages);
		$gartentechnik_com_admin_get_all_pages = null;
		gartentechnik_com_debug('get_all_pages_end');

		// Don't forget to exit!
		exit;
	}, 20, 0);
}
// VOID
function gartentechnik_com_wp_fehlermeldung($message) {
	add_action( 'admin_notices', function() use($message) {
		gartentechnik_com_debug('admin_notice_start');
		printf( '<div class="notice notice-error"><p>%2$s</p></div>', esc_html( $message ) );
		gartentechnik_com_debug('admin_notice_end');
	});
}
?>
