<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

{# Ist bereits der init-Context
	$gartentechnik_com_suchergebnis_cache = [];
    if(\GartentechnikCom\Register::ist_such_autovervollstaendigung()) {
		add_filter('the_posts', function($wp_posts, $query=null) use ($app) {
			global $gartentechnik_com_suchergebnis_cache;
			global $gartentechnik_com_special_post_id;
			if(
				$query
				&& (
					!array_key_exists('post_type', $query->query_vars)
					|| $query->query_vars['post_type'] == ''
					|| $query->query_vars['post_type'] == 'page'
					|| $query->query_vars['post_type'] == 'post'
					|| $query->query_vars['post_type'] == 'any'
					|| !array_key_exists('s', $query->query_vars)
				)
			) {
				gartentechnik_com_debug('the_posts_filter_start');
				$suchstring = sanitize_text_field(stripcslashes($_POST['s']));
				if(!is_array(@$gartentechnik_com_suchergebnis_cache[$suchstring])) {
					$gartentechnik_com_suchergebnis_cache[$suchstring] = $app->gib_suchergebnisse($suchstring);
				}
				$trefferListe = $gartentechnik_com_suchergebnis_cache[$suchstring];
				$posts = array_splice($wp_posts, 0, 3);
				foreach ($trefferListe as $treffer) {
					$post = new stdClass;
					$post->post_content = '-';
					$post->post_title = $treffer['titel'];
					$post->post_name = $treffer['link'];
					if(preg_match('/^(.*?)\-(\d+)/', $treffer['ID'], $hits)) {
						if($hits[1] == 'zentral') {
							$post->ID = $gartentechnik_com_special_post_id + $hits[2];
						} else {
							$post->ID = $gartentechnik_com_special_post_id - $hits[2];
						}
					} else {
						$post->ID = $gartentechnik_com_special_post_id + 10000000 + array_sum(
							array_map(
								function($n){return ord($n);},
								preg_split('//', $treffer['link'], -1, PREG_SPLIT_NO_EMPTY)
							)
						);
					}
					$post->post_author = 1;
					$post->post_date = current_time('mysql');
					$post->post_date_gmt = current_time('mysql', 1);
					$post->post_excerpt = '  ';# Wenn leer, wird (manchmal) das Datum genommen
					$post->post_status = 'publish';
					$post->comment_status = 'closed';
					$post->ping_status = 'closed';
					$post->post_password = '';
					$post->to_ping = '';
					$post->pinged = '';
					$post->modified = $post->post_date;
					$post->modified_gmt = $post->post_date_gmt;
					$post->post_content_filtered = '';
					$post->post_parent = 0;
					$post->guid = get_home_url('/' . $post->post_name);
					$post->menu_order = 0;
					$post->post_type = 'page';
					$post->post_mime_type = '';
					$post->comment_count = 0;
					wp_cache_add($post->ID, $post, 'posts');

					array_push($posts, $post);
				}
				$wp_posts = $posts;
				gartentechnik_com_debug('the_posts_filter_end');
			}
			return $wp_posts;
		}, 20, 2);
	}
}
?>
