<?php

function gtcom_rest_v4(WP_REST_Request $request) {
    $path_chunks = explode('/gartentechnik-com/v4/', $request->get_route(), 2);
    if(
        array_key_exists('GARTENTECHNIK_COM_IS_DOCKER_CONTEXT', $_SERVER)
        && $_SERVER['GARTENTECHNIK_COM_IS_DOCKER_CONTEXT'] == '1'
    ) {
        $url_base = 'http://pyapi:8080/woocommerce_api/gt-api-gateway/';
    } else {
        $url_base = 'https://www.gartentechnik.com/api/motorist_plugin/v3/woocommerce_api/gt-api-gateway/';
    }
    //    if (getenv('SERVERCONTEXT') === 'prod') { // TODO read url_base directly from env instead of using a context
    //        $url_base = 'https://www.gartentechnik.com/pyapi/';
    //    } else {
    //        $url_base = 'http://gt-api-gateway/';
    //    }
    $url = $url_base . $path_chunks[1] . ($request->get_query_params() ? '?' . http_build_query($request->get_query_params()) : '');

    $headers = $request->get_headers();
    $api_key = \GartentechnikCom\EinstellungsRegister::gib_einstellung('gartentechnik_com_api_key');
    $headers[] = 'X-GTCOM-API-KEY: ' . $api_key;
    $headers[] = 'X-WORDPRESS-API-KEY: ' . $api_key;

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST,  $request->get_method());
    curl_setopt($ch, CURLOPT_HTTPHEADER,     $headers);
    curl_setopt($ch, CURLOPT_POSTFIELDS,     $request->get_body());
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT,        600);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

    $data = curl_exec($ch);
    if ($data === false) {
        header('HTTP/2 420 Enhance Your Calm');
        die(curl_error($ch));
    } else {
        $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        header('HTTP/2 ' . $code);
        echo $data;
    }
    curl_close($ch);
    exit(0);
}

add_action('rest_api_init', function () {
    register_rest_route('gartentechnik-com/v4' , '(.*)', [
        'methods' => ['GET', 'POST', 'PUT'],
        'callback' => 'gtcom_rest_v4',
        'permission_callback' => '__return_true'
    ]);
});
