<?php
	if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
	
	/* Sektionseinteilung */
	add_settings_section(
		'gartentechnik_com_api',
		'',# Titel der Sektion
		function($args) {}, # Untertitel der Sektion
		'gartentechnik_com'
	);
	
	/* API-Key */
	add_settings_field(
		'gartentechnik_com_api_key',
		'API-Key',
		function($args) {
			?>
				<input
					type="text"
					id="gartentechnik_com_api_key"
					name="gartentechnik_com_einstellungen[gartentechnik_com_api_key]"
					value="<?php echo esc_attr(\GartentechnikCom\EinstellungsRegister::gib_einstellung('gartentechnik_com_api_key')) ?>"
					size="80"
				/>
				<p class="description">Der Schlüssel für Ihren Gartentechnik.com Account</p>
			<?php
		},
		'gartentechnik_com',
		'gartentechnik_com_api'
	);

	/* Validierung */
	register_setting('gartentechnik_com', 'gartentechnik_com_einstellungen', function($felder) {
		$validierte_felder = array();
		foreach($felder as $key => $val) {
			$validierte_felder[$key] = trim(strip_tags(stripslashes($felder[$key])));
		}

		add_settings_error(
			'gartentechnik_com_messages',
			'gartentechnik_com_message',
			'Der API-Key wurde gespeichert',
			'updated'
		);
		return apply_filters( 'validate_options', $validierte_felder, $felder);
	});
?>
