<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if(\GartentechnikCom\Register::api_key_ist_ungueltig()) {
	# DoNothing
} else {
	register_post_type( 'gartentechnik_com_me',
		array(
			'labels' => array(
				'name'		=> 'Navigationsmenü',
				'menu_name'	=> '10-Navigationsmenü',
			),
			'public' => false,
			'exclude_from_search'	=> true,
			'publicly_queryable'	=> false,
			'show_ui'	=> true,
			'show_in_menu'	=> 'gartentechnik_com-admin',
			'show_in_nav_menus'	=> true,
			'has_archive' => false,
			'show_in_admin_bar'	=> true,
			'hierarchical'	=> false,
			'rewrite'	=> false,
			'supports'	=> [
				'title',
			],
		)
	);
	\GartentechnikCom\Register::wp_admin_topmenue(array(
		array(
			'id'		=> 'gartentechnik_com-topmenue-gartentechnik_com-admin-gartentechnik_com_me',
			'title'		=> '10-Navigationsmenü',
			'href'		=> esc_url(admin_url('edit.php')) . '?post_type=gartentechnik_com_me',
			'parent'	=> 'gartentechnik_com-topmenue',
		)
	));
	
	# Listenansicht
	add_filter('manage_gartentechnik_com_me_posts_columns' , function($columns) {
		gartentechnik_com_debug('posts_columns');
		unset($columns['date']);
		$new_columns = array(
			'filter' => 'Produkte filtern',
			'kategorie' => 'Kategorie',
			'tiefe' => 'Wie viele Ebenen von Unterkategorien sollen gezeigt werden',
		);
		return array_merge($columns, $new_columns);
	}, 20, 1);
	add_action('manage_gartentechnik_com_me_posts_custom_column' , function($column, $post_id) use ($response) {
		gartentechnik_com_debug('post_custom_coloumns_start');
		$kategoriebaum = $response->kategoriebaum();
		$uebersetzung_kat = [];
		foreach($kategoriebaum as $k) {
			$uebersetzung_kat[$k['url_name']] = $k['name'];
		}
		$uebersetzung_filter = [
			'alle'		=> 'Alle anzeigen',
			'neu'		=> 'Nur Neugeräte',
			'gebraucht'	=> 'Nur Gebrauchte',
			'mieten'	=> 'Nur Mietgeräte',
			'angebote'	=> 'Nur Angebote',
		];
		switch ( $column ) {
			case 'kategorie':
				echo $uebersetzung_kat[get_post_meta($post_id, 'kategorie', true)];
				break;
				
			case 'filter':
				echo $uebersetzung_filter[get_post_meta($post_id, 'filter', true)];
				break;
	
			case 'tiefe':
				echo get_post_meta($post_id, 'tiefe', true);
				break;
		}
		gartentechnik_com_debug('post_custom_coloumns_end');
	}, 20, 2);
	# Editor
	add_action('add_meta_boxes_gartentechnik_com_me', function() use ($response) {
		gartentechnik_com_debug('metabox_start');
		add_meta_box('gartentechnik_com_me-felder', 'Einstellungen', function($post) use ($response) {
			$kategorie = get_post_meta($post->ID, 'kategorie', true);
			$filter = get_post_meta($post->ID, 'filter', true);
			$tiefe = get_post_meta($post->ID, 'tiefe', true);
			
			$menue = \GartentechnikCom\Register::get_wp_menue();
			$kategoriebaum = $response->kategoriebaum();
			echo $menue->gib_editiermaske($kategorie, $filter, $tiefe, $kategoriebaum);
		}, 'gartentechnik_com_me', 'normal', 'default');
		add_action('post_submitbox_start', function() {# Blende Freigabe aus
			echo '<style>#submitdiv #minor-publishing { display: none; }</style>';
			echo '<script> jQuery(function() { jQuery("#publish").val("Speichern"); });</script>';
		}, 20, 0);
		gartentechnik_com_debug('metabox_end');
	}, 20, 0 );
	add_action('save_post', function($post_id, $post) {
		gartentechnik_com_debug('save_post_start');
		if(!$post || $post->post_type != 'gartentechnik_com_me') {
			return;
		}
		
		add_post_meta($post_id, 'filter', '', true);
		add_post_meta($post_id, 'kategorie', '', true);
		add_post_meta($post_id, 'tiefe', '', true);
	
		$filter = sanitize_text_field( $_POST['gartentechnik_com_me_filter'] );
		$kategorie = sanitize_text_field( $_POST['gartentechnik_com_me_kategorie'] );
		$tiefe = 0;
		if (ctype_digit($_POST['gartentechnik_com_me_tiefe'])) {
			$tiefe = $_POST['gartentechnik_com_me_tiefe'];
		}
	
		update_post_meta($post_id, 'filter', $filter, false);
		update_post_meta($post_id, 'kategorie', $kategorie, false);
		update_post_meta($post_id, 'tiefe', $tiefe, false);
		gartentechnik_com_debug('save_post_end');
	}, 20, 2);
	# Frontend
	add_filter('wp_nav_menu_objects', function($sorted_menu_items, $args) use ($response) {
		gartentechnik_com_debug('nav_menu_start');
		$menue = \GartentechnikCom\Register::get_wp_menue();
		$kategoriebaum = $response->kategoriebaum();
		
		foreach($sorted_menu_items as $e) {
			if($e->object != 'gartentechnik_com_me') {
				continue;
			}
			
			$kategorie = get_post_meta($e->object_id, 'kategorie', true);
			$filter = get_post_meta($e->object_id, 'filter', true);
			$tiefe = get_post_meta($e->object_id, 'tiefe', true);
			
			$auffueller_items = $menue->gib_menue_items($kategoriebaum, $e, $kategorie, $filter, $tiefe);
			$sorted_menu_items = array_merge($auffueller_items, $sorted_menu_items);
		}
		gartentechnik_com_debug('nav_menu_end');
		return $sorted_menu_items;
	}, 20, 2);
}
?>
