<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

$gartentechnik_com_rss_import_no_rss_cache = false;
add_filter('cron_schedules', function($schedules) {
	$schedules['every_third_hour'] = array(
		'interval' => 3600 * 3,
		'display' => __('Every third hour')
	);
	return $schedules;
});
add_filter('wp_feed_cache_transient_lifetime' , function($seconds) use(&$gartentechnik_com_rss_import_no_rss_cache) {
	if($gartentechnik_com_rss_import_no_rss_cache) {
		return 45 * 60;
	}
	return $seconds;
});
add_action('gartentechnik_com_rss_import', function() use(&$gartentechnik_com_rss_import_no_rss_cache) {
	gartentechnik_com_debug("RSS-Import-Start");
	require_once(__DIR__ . '/classes/RSSImporter.php');

	$domain = $_SERVER['HTTP_HOST'];
	if(preg_match('/^https?:\/\/([^\/]+)/', home_url('/'), $wp_url_hits)) {
		$domain = $wp_url_hits[1];
	}
	$gartentechnik_com_rss_import_no_rss_cache = true;
	$importer = new \GartentechnikCom\RSSImporter();
	try {
		$importer->import($domain);
		$msg = $importer->get_log_messages();
	} catch (exception $e) {
		$msg = "$e";
	}
	#if(array_key_exists('GARTENTECHNIK_COM_IS_DOCKER_CONTEXT', $_SERVER) && $_SERVER['GARTENTECHNIK_COM_IS_DOCKER_CONTEXT'] == '1') {
	#	$fh = fopen('/var/www/wordpress/htdocs/wp-content/crondebug.log', "a");
	#	if($fh) {
	#		fwrite($fh, "---START--- $domain ---\n" . $msg);
	#		fclose($fh);
	#	}
	#}
	$gartentechnik_com_rss_import_no_rss_cache = false;
	gartentechnik_com_debug("RSS-Import-End");
}, 10, 0);
function gartentechnik_com_rss_activation() {
	if(!wp_next_scheduled('gartentechnik_com_rss_import')) {
		gartentechnik_com_debug("RSS-Activate");
		wp_schedule_event(time() + rand(0, 3600*3), 'every_third_hour', 'gartentechnik_com_rss_import');
	}
}
function gartentechnik_com_rss_deactivation() {
    wp_clear_scheduled_hook('gartentechnik_com_rss_import');
}

register_activation_hook(__FILE__, 'gartentechnik_com_rss_activation');
register_deactivation_hook(__FILE__, 'gartentechnik_com_rss_deactivation');
?>
