<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

add_filter('the_posts', function($posts, $query = null) use ($response) {
	if(
		$query
		&& $query->query_vars
		&& (
			!array_key_exists('post_type', $query->query_vars)
			|| $query->query_vars['post_type'] != ''
		)
	) {
		return ($posts);
	}

	gartentechnik_com_debug('the_posts_start');
	if(
		!\GartentechnikCom\Register::zeige_gtcom()
		||
		\GartentechnikCom\Register::ignoriere_the_posts_hook()
		||
		\GartentechnikCom\Register::ist_such_autovervollstaendigung()
	) {
		gartentechnik_com_debug('default posts');
		return ($posts);
	}

	global $wp_query;
	global $gartentechnik_com_special_post_id;
	$wp_query->is_page = TRUE;
	$wp_query->is_singular = TRUE;
	$wp_query->is_home = FALSE;
	$wp_query->is_archive = FALSE;
	$wp_query->is_category = FALSE;
	$wp_query->is_search = FALSE;
	unset($wp_query->query['error']);
	$wp_query->query_vars['error'] = '';
	$wp_query->is_404 = FALSE;

	$post = \GartentechnikCom\Register::virtueller_post();
	if(!is_null($post)) {
		gartentechnik_com_debug('no vpost');
		return array($post);
	}

	$post = new stdClass;
	$post->post_content = $response->main_content();
	$post->post_title = $response->html_head_titel();
	gartentechnik_com_debug('the_post_title:' . $post->post_title);
	gartentechnik_com_debug('the_post_content:' . substr(preg_replace('/\n/', ' ', $post->post_content), 0, 500));
	$post->post_name = $_SERVER['REQUEST_URI'] . '#';

	$post->ID = $gartentechnik_com_special_post_id;
	$post->post_author = 1;
	$post->post_date = current_time('mysql');
	$post->post_date_gmt = current_time('mysql', 1);
	$post->post_excerpt = '';
	$post->post_status = 'publish';
	$post->comment_status = 'closed';
	$post->ping_status = 'closed';
	$post->post_password = '';
	$post->to_ping = '';
	$post->pinged = '';
	$post->modified = $post->post_date;
	$post->modified_gmt = $post->post_date_gmt;
	$post->post_content_filtered = '';
	$post->post_parent = 0;
	$post->guid = get_home_url('/' . $post->post_name);
	$post->menu_order = 0;
	$post->post_type = 'page';
	$post->post_mime_type = '';
	$post->comment_count = 0;
	wp_cache_add($post->ID, $post, 'posts');

	gartentechnik_com_debug('special post');
	$replace_function = function() {
		ob_start(function($buffer, $post) {
			$buffer = preg_replace('/<meta p.* \/>/', '', $buffer);
			return $buffer;
		});
	};
	add_action('template_redirect', $replace_function, -1);
	add_action('get_header', $replace_function);
	add_action('wp_footer', function() {
		ob_end_flush();
	}, 999);
	add_filter( 'body_class', function($classes) {
		$classes[] = 'gartentechnik_com_body';
		return $classes;
	});
	add_filter( 'wpseo_opengraph_type', function($type) {
		return 'product';
	}, 20, 1 );
	add_filter( 'wpseo_metadesc', function($type) use ($response) {
		return $response->html_head_metadescription();
	}, 20, 1 );

	\GartentechnikCom\Register::virtueller_post($post);
	gartentechnik_com_debug('the_posts_end');
	return (array($post));
}, 20, 2);

add_filter( 'the_title', function($title, $id = 0) use ($response) {
	global $gartentechnik_com_special_post_id;
	# gartentechnik_com_debug('the_title');
	if ($id == $gartentechnik_com_special_post_id) {
		return $response->html_content_titel();
	}
	return $title;
}, 20, 2);

add_action('send_headers', function() use ($response) {
	gartentechnik_com_debug('send_header_start');
	if($response->redirect_location()) {
		gartentechnik_com_debug('301');
		header("HTTP/1.1 301 MovedPermanently");
		header('Location: ' . $response->redirect_location());
	} elseif($response->is_404()) {
		gartentechnik_com_debug('404');
		if($response->send_explicit_http_response_code()) {
			header("HTTP/1.1 404 NotFound");
		}
	} else {
		gartentechnik_com_debug('200');
		if($response->send_explicit_http_response_code()) {
			header("HTTP/1.1 200 OK");
		}
	}
	gartentechnik_com_debug('send_header_end');
}, 20, 0);

add_filter('user_trailingslashit', function($url, $type) {
	# gartentechnik_com_debug('trailingslash');
	if(\GartentechnikCom\Register::zeige_gtcom()) {
		if(preg_match('/#$/', $url)) {
			return $url;
		}
		return trailingslashit($url);
	}
	return $url;
}, 20, 2);
?>
