<?php
namespace GartentechnikCom;

if (!defined('ABSPATH')) exit; // Exit if accessed directly

class Register {
	static private $instances = [];
	static private $domain = '';
	static private $current_path = '';
	static private $zeige_gtcom = false;
	static private $virtueller_post = null;
	static private $ist_eine_suche = false;
	static private $suchquery = '';
	static private $ignoriere_the_posts_hook = false;
	static private $ist_such_autovervollstaendigung = false;
	static private $wp_admin_topmenue = [];
	static private $app = null;
	static private $plugin_version = '0';
	static private $api_version = '0';
	static private $api_key_ist_ungueltig = false;
	static private $api_key_fehler_details = '';
	static private $api_key_ist_testaccount = false;
	static private $api_key_testaccount_gueltigkeit_in_tagen = 0;
	static private $api_key_darf_testaccount_beantragen = false;
	static private $api_key_testzeitraum_fehlermeldung = '';

	# VOID
	public static function init($domain, $current_path, $app, $plugin_version, $api_version) {
		self::$domain = $domain;
		self::$current_path = $current_path;
		self::$app = $app;
		self::$plugin_version = $plugin_version;
		self::$api_version = $api_version;
	}

	# ARRAY || NULL
	public static function gib_widget_produktansicht($id) {
		return self::$app->gib_widget_produktansicht($id);
	}

	# ARRAY
	public static function gib_post_slug($post) {
		$parents = get_post_ancestors($post);
		$slugs = [];
		foreach (array_reverse($parents) as $parent_ID) {
			array_push($slugs, get_post($parent_ID)->post_name);
		}
		array_push($slugs, $post->post_name);
		return $slugs;
	}

	# STRING
	public static function gib_plugin_version() {
		return self::$plugin_version;
	}

	# STRING
	public static function gib_api_version() {
		return self::$api_version;
	}

	# OBJ
	public static function get_wp_menue() {
		$instance = @self::$instances['menue'];
		if (is_null($instance)) {
			$instance = new \GartentechnikCom\WP\Menue();
			self::$instances['menue'] = $instance;
		}
		return $instance;
	}

	# STRING
	public static function erzeuge_link($typ, $element) {
		$instance = @self::$instances['linkerzeuger'];
		if (is_null($instance)) {
			$instance = new \GartentechnikCom\Linkerzeuger();
			self::$instances['linkerzeuger'] = $instance;
		}
		return $instance->erzeuge_link($typ, $element);
	}

	# STRING
	public static function gib_aktuellen_pfad() {
		return self::$current_path;
	}

	# BOOLEAN
	public static function zeige_gtcom($val = null) {
		if (!is_null($val)) self::$zeige_gtcom = $val;

		return self::$zeige_gtcom;
	}

	# OBJ || NULL
	public static function virtueller_post($post = null) {
		if (!is_null($post)) self::$virtueller_post = $post;

		return self::$virtueller_post;
	}

	# BOOLEAN
	public static function ist_eine_suche($val = null) {
		if (!is_null($val)) self::$ist_eine_suche = $val;

		return self::$ist_eine_suche;
	}

	# STRING
	public static function suchquery($val = null) {
		if (!is_null($val)) self::$suchquery = $val;

		return self::$suchquery;
	}

	# BOOLEAN
	public static function ignoriere_the_posts_hook($val = null) {
		if (!is_null($val)) self::$ignoriere_the_posts_hook = $val;

		return self::$ignoriere_the_posts_hook;
	}

	# BOOLEAN
	public static function ist_such_autovervollstaendigung($val = null) {
		if (!is_null($val)) self::$ist_such_autovervollstaendigung = $val;

		return self::$ist_such_autovervollstaendigung;
	}

	# ARRAY
	public static function wp_admin_topmenue($array = null) {
		if (!is_null($array)) self::$wp_admin_topmenue = $array;

		return self::$wp_admin_topmenue;
	}

	# BOOLEAN
	public static function api_key_ist_ungueltig($ungueltig = null) {
		if (!is_null($ungueltig)) self::$api_key_ist_ungueltig = $ungueltig ? true : false;

		return self::$api_key_ist_ungueltig;
	}

	# ARRAY
	public static function api_key_fehler_details($details = null) {
		if (!is_null($details)) self::$api_key_fehler_details = $details;

		return self::$api_key_fehler_details;
	}

	# BOOLEAN
	public static function api_key_ist_testaccount($ist_testaccount = null) {
		if (!is_null($ist_testaccount)) self::$api_key_ist_testaccount = $ist_testaccount ? true : false;

		return self::$api_key_ist_testaccount;
	}

	# BOOLEAN
	public static function api_key_testaccount_gueltigkeit_in_tagen($testaccount_gueltigkeit_in_tagen = null) {
		if (!is_null($testaccount_gueltigkeit_in_tagen)) self::$api_key_testaccount_gueltigkeit_in_tagen = $testaccount_gueltigkeit_in_tagen;

		return self::$api_key_testaccount_gueltigkeit_in_tagen;
	}

	# BOOLEAN
	public static function api_key_darf_testaccount_beantragen($darf_beantragen = null) {
		if (!is_null($darf_beantragen)) self::$api_key_darf_testaccount_beantragen = $darf_beantragen ? true : false;

		return self::$api_key_darf_testaccount_beantragen;
	}

	# STRING
	public static function api_key_testzeitraum_fehlermeldung($text = null) {
		if (!is_null($text)) self::$api_key_testzeitraum_fehlermeldung = $text;

		return self::$api_key_testzeitraum_fehlermeldung;
	}
}

?>
