<?php
namespace GartentechnikCom\WP;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Menue {
	# VOID
	function __construct() {
	}
	public function gib_menue_items($kategoriebaum, $platzhalter_item, $kategorie, $filter, $maximale_tiefe) {
		$platzhalter_ID = $platzhalter_item->ID;
		$menue = [];
		$filtername = 'anzahl_' . $filter;
		if($filter == 'alle') {
			$filtername = 'anzahl';
		} else if ($filter == 'angebot') {
			$filtername = 'anzahl_angebote';
		}
		$aktuelle_url = \GartentechnikCom\Register::gib_aktuellen_pfad();

		$gewaehlte_kategorie = null;
		$vater_id = 0;
		$kindermarkierung_gesetzt = false;
		foreach($kategoriebaum as $kat) {
			if($gewaehlte_kategorie != null && $kat['tiefe'] <= $gewaehlte_kategorie['tiefe']) {
				break;
			}

			if($gewaehlte_kategorie == null && $kat['url_name'] == $kategorie) {
				$platzhalter_item->url = \GartentechnikCom\Register::erzeuge_link('kategorie', [
					'kategorie'		=> $kat['url_name'],
					'filter'		=> $filter,
				]);
				if(@$kat[$filtername] > 0) {
					$gewaehlte_kategorie = $kat;
					$vater_id = $platzhalter_item->ID;
				}
				if($aktuelle_url == $platzhalter_item->url) {
					$this->_markiere_ist_aktuelles_item($platzhalter_item);
				}
				continue;
			}
			if($gewaehlte_kategorie == null) {
				continue;
			}
			$aktuelle_tiefe = $kat['tiefe'] - $gewaehlte_kategorie['tiefe'];
			if($aktuelle_tiefe > $maximale_tiefe) {
				continue;
			}

			if($kat[$filtername] == 0) {
				continue;
			}

			if(!$kindermarkierung_gesetzt) {
				$this->_markiere_item_hat_kinder($platzhalter_item);
				$kindermarkierung_gesetzt = true;
			}

			$new_item = $this->_kategorie_als_post($kat, $filter, $platzhalter_ID);
			if($kat['tiefe'] == $gewaehlte_kategorie['tiefe'] + 1) {
				$new_item->menu_item_parent = $vater_id;
			}
			if($kat['kinder'] > 0 && $aktuelle_tiefe + 1 <= $maximale_tiefe) {
				$this->_markiere_item_hat_kinder($new_item);
			}
			if($aktuelle_url == $new_item->url) {
				$this->_markiere_ist_aktuelles_item($new_item);
			}

			array_push($menue, $new_item);
		}
		return $menue;
	}
	private function _markiere_ist_aktuelles_item($item) {
		array_push($item->classes, 'current_page_item');
		array_push($item->classes, 'current-menu-item');
	}
	private function _markiere_item_hat_kinder($item) {
		array_push($item->classes, 'menu-item-has-children');
	}
	private function _erzeuge_eindeutige_id($kat_id, $platzhalter_ID) {
		return sprintf('gartentechnik_com-%d.%d', $platzhalter_ID, $kat_id);
	}
	private function _kategorie_als_post($kat, $filter, $platzhalter_ID) {
		$id = $this->_erzeuge_eindeutige_id($kat['ID'], $platzhalter_ID);
		$post = new \stdClass();
		$post->ID = $id;
		$post->db_id = $id;
		$post->title = $kat['name'];
		$post->url = \GartentechnikCom\Register::erzeuge_link('kategorie', [
			'kategorie'		=> $kat['url_name'],
			'filter'		=> $filter,
		]);
		$post->menu_item_parent = $this->_erzeuge_eindeutige_id($kat['vater_ID'], $platzhalter_ID);
		$post->classes = ['menu-item', 'menu-item-type-post_type', 'menu-item-object-page'];
		$post->target = null;
		$post->xfn = null;
		$post->current = null;
		return $post;
	}
	public function gib_editiermaske($kategorie, $filter, $tiefe, $kategoriebaum) {
		require(__DIR__ . '/../../templates/menue_editor.tpl.php');
	}
}
?>
