<?php
namespace GartentechnikCom\Widget;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

require_once(__DIR__ . '/../Widget.php');

class Haendleradresse extends \GartentechnikCom\Widget {
	function __construct() {
		parent::__construct('gartentechnik-com-haendleradresse', 'Händleradresse', 'Platzhalter, der durch die GT-Händleradresse ersetzt wird');
	}
	# STRING
	protected function _get_content($args, $instance) {
		$title = apply_filters('widget_title', @$instance['title']);
		if(!empty($title)) {
			$title = @$args['before_title'] . $title . @$args['after_title'];
		}
		$inhalt = $this->response->widget_haendleradresse();
		if (!$instance['show_additional']) {
			$inhalt = preg_replace('/<li><a.*li>/', '', $inhalt);
			$inhalt = preg_replace('/<li class.*li>/', '', $inhalt);
		}
		return $title . $inhalt;
	}
	# VOID
	public function form($instance) {
		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}
		if (isset($instance['show_additional'])) {
			$show_additional = $instance['show_additional'];
		} else {
			$show_additional = null;
		}
		require(__DIR__ . '/../../templates/haendleradressewidget_editor.tpl.php');
	}
	# OBJ
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['show_additional'] = ( ! empty( $new_instance['show_additional'] ) ) ? strip_tags( $new_instance['show_additional'] ) : '';
		return $instance;
	}
}
?>
