<?php if (!defined('ABSPATH')) exit; // Exit if accessed directly ?>

<div class="wrap gartentechnik_com-admin">
	<h2>API-Key für die Verwendung des Gartentechnik.com-Wordpress-Plugin</h2>
	<?php
		if(\GartentechnikCom\Register::api_key_testzeitraum_fehlermeldung()) {
			add_settings_error(
				'gartentechnik_com_messages',
				'gartentechnik_com_message',
				\GartentechnikCom\Register::api_key_testzeitraum_fehlermeldung(),
				'error'
			);
		}
		if(\GartentechnikCom\Register::api_key_ist_testaccount()) {
			if(\GartentechnikCom\Register::api_key_ist_ungueltig()) {
				add_settings_error(
					'gartentechnik_com_messages',
					'gartentechnik_com_message',
					"Ihr Testzeitraum ist abgelaufen. Bitte kontaktieren Sie das Gartentechnik.com-Team, z.B. "
					. "mit dem Kontaktformular unten, um ihren Account wieder zu aktivieren.",
					'error'
				);
			} else {
				$gueltigkeit_in_tagen = \GartentechnikCom\Register::api_key_testaccount_gueltigkeit_in_tagen();
				$text = "Ihr Testzeitraum läuft noch $gueltigkeit_in_tagen Tage.";
				if($gueltigkeit_in_tagen <= 0) {
					$text = "ACHTUNG: Ihr Testzeitraum läuft nur noch heute.";
				}
				add_settings_error(
					'gartentechnik_com_messages',
					'gartentechnik_com_message',
					$text,
					'info'
				);
			}
		} else if(
			\GartentechnikCom\EinstellungsRegister::gib_einstellung('gartentechnik_com_api_key')
			&&
			\GartentechnikCom\Register::api_key_ist_ungueltig()
		) {
			$msg = \GartentechnikCom\Register::api_key_fehler_details();
			if(!$msg) $msg = 'Der API-Key ist nicht gültig';
			add_settings_error(
				'gartentechnik_com_messages',
				'gartentechnik_com_message',
				$msg,
				'error'
			);
		}
		settings_errors('gartentechnik_com_messages');
	?>

	<?php
		if(
			\GartentechnikCom\Register::api_key_darf_testaccount_beantragen()
			&& !\GartentechnikCom\EinstellungsRegister::gib_einstellung('gartentechnik_com_api_key')
			&& !array_key_exists('direkteingabe', $_GET)
		) {
	?>
		<form method="POST">
			<p><strong>Vielen Dank</strong>, dass Sie das Gartentechnik.com-Plugin bereits heruntergeladen
				und im Rahmen Ihrer WordPress-Instanz installiert haben!</p>
			<p>Wenn Sie jetzt den <strong>90-tägigen Testzeitraum</strong> aktivieren, geschieht dies <strong>ohne
				jedwede Verpflichtung</strong>: Wir informieren Sie vor Ablauf über das nahende Ende des Tests und
				geben Ihnen die Möglichkeit, den weiteren Betrieb sicherzustellen. Sollten Sie schon jetzt oder in
				der Zwischenzeit Fragen oder Anregungen haben, sprechen Sie uns bitte an.</p>
			<p>Bei Nichtgefallen brauchen Sie übrigens nichts weiter zu unternehmen: Das Plugin stellt von allein
				den Betrieb ein und kann von Ihnen später jederzeit gelöscht werden. Eine Kündigung ist nicht
				erforderlich. - Ein weiterer Test unter derselben Domain ist ohne Unterstützung allerdings nicht
				möglich, sprechen Sie uns bei erneutem Interesse einfach an.</p>
			<input type="hidden" name="gartentechnik_com_action" value="generiere_testaccount_api_key"/>
			<input
				class="button button-primary"
				type="submit"
				value="Jetzt kostenfrei 90 Tage testen - mit allen Funktionen von Gartentechnik.com!"
			/>
			<p><strong>Alternativ</strong>: <a href="?page=gartentechnik_com-admin-wp-api-key&direkteingabe=1">geben
				Sie hier den API-Key direkt ein</a>, den Sie von Gartentechnik.com erhalten haben.</p>
		</form>
	<?php
		} else {
			if(\GartentechnikCom\Register::api_key_ist_testaccount()) {
				if(\GartentechnikCom\Register::api_key_ist_ungueltig()) {
	?>
					<p><strong>Vielen Dank</strong>, dass Sie das Gartentechnik.com-Plugin <strong>90 Tage lang auf Herz und Nieren getestet</strong>
					haben. Dank der umfangreichen Produktinformationen Ihrer Lieferanten, die wir fortlaufend für alle unsere Kunden zentral
					pflegen, wurde die Sichtbarkeit Ihrer WordPress-Website in Suchmaschinen gravierend erhöht.</p>
					<p>Wenn Sie auch morgen Ihr Produktportfolio umfangreich präsentieren, Gebrauchte und Mietgeräte über unsere Plattformen
					anbieten, dadurch wieder gut gefunden und unter dem Strich mehr Anfragen von Kunden und Interessenten erhalten und
					Verkäufe realisieren möchten, sprechen Sie uns bitte an.</p>
					<p>Wir beraten Sie sehr gerne bei der Auswahl Ihrer Gartentechnik.com-Lizenz und unterstützen Sie darüber hinaus gerne
					mit zusätzlichen Leistungen für Ihr Onlinemarketing. Erste Informationen zu Preisen und Konditionen erhalten Sie
					sofort online unter: <a href="https://preis.gartentechnik.com" target="_blank">Preis.Gartentechnik.com</a></p>
					<hr/>
	<?php
				} else {
					$text_restliche_gueltigkeit = \GartentechnikCom\Register::api_key_testaccount_gueltigkeit_in_tagen();
					if($text_restliche_gueltigkeit <= 0) {
						$text_restliche_gueltigkeit = 'nur noch kurze Zeit';
					} else {
						$text_restliche_gueltigkeit = "$text_restliche_gueltigkeit Tage Zeit";
					}
	?>
					<p><strong>Vielen Dank</strong>, dass Sie das Gartentechnik.com-Plugin auf Herz und Nieren testen möchten.
					Sie haben jetzt <strong><?php echo $text_restliche_gueltigkeit; ?></strong>,
					Ihre Website mit umfangreichen <strong>Produktinformationen</strong> Ihrer Lieferanten auszustatten, darüber eine hohe
					<strong>Sichtbarkeit in Suchmaschinen</strong> und unmittelbare Anfragen zu erhalten.</p>
		
					<p>Ein paar <strong>Tipps</strong>, die erfahrungsgemäß für besonders viel <strong>Erfolg</strong> sorgen:</p>
					<ol>
						<li>Legen Sie <strong>Angebote</strong> an. Diese werden nicht nur auf Ihrer Website sondern auch im Rahmen unserer Lokalplattformen unter
							Gartentechnik.com ausgestrahlt und sorgen für mehr Aufmerksamkeit. - Gleiches gilt für <strong>Mietgeräte</strong>, wenn Sie im Mietgeschäft
							aktiv sind.</li>
						<li>Stellen Sie Ihre unbedingt <strong>Gebrauchtmaschinen</strong> ein! Diese werden nicht nur in den lokalisierten Plattformen sondern
							zusätzlich unter Gebrauchte.Gartentechnik.com sichtbar sein und unterstützen Sie beim bundesweiten Verkauf - und häufig
							genug sogar darüber hinaus!</li>
						<li>Umfangreiche <strong>Informationen</strong> zum Plugin finden Sie in unserem YouTube-Kanal unter:
							<a href="https://www.youtube.com/user/GartentechnikCom" target="_blank">YouTube.com/Gartentechnikcom</a></li>
						<li>Aber auch während des Testzeitraums können Sie gerne auf persönliche Hilfe zurückgreifen:
							<strong>Schreiben Sie uns oder sprechen Sie uns telefonisch an!</strong></li>
					</ol>
					<p>Wir wünschen Ihnen viel Erfolg mit dem Gartentechnik.com-Plugin und freuen uns, Sie nach dem Ablauf des Testzeitraums als
					Kunde begrüßen zu können!</p>
					<hr/>
	<?php
				}
			}
	?>

		<p><strong>WICHTIG</strong>: Wenn Sie sich nicht ganz sicher sind, was Sie auf dieser Seite machen, nehmen
			Sie bitte unbedingt zuerst Kontakt zu auf!</p>
			
		<form action="options.php" method="post">
			<?php
			settings_fields('gartentechnik_com');
			do_settings_sections('gartentechnik_com');
			submit_button('Schlüssel speichern');
			?>
			<?php
				if(
					\GartentechnikCom\Register::api_key_darf_testaccount_beantragen()
					&& !\GartentechnikCom\EinstellungsRegister::gib_einstellung('gartentechnik_com_api_key')
				) {
			?>
				<a href="?page=gartentechnik_com-admin-wp-api-key">
					Zurück zur Testzeitraum-Erstellung
				</a>
			<?php
				}
			?>
		</form>
	
	<?php
		}
	?>
	
	<?php include('footer_kontaktbox.html'); ?>
</div>
